#include "globals.h"
#include ".\propsdlg.h"
#include "resource.h"
#include "TlbHotKeyCtl.h"
#include <CommCtrl.h>

//////////////////////////////////////////////////////////////////////////

CPageAbout::CPageAbout(CPropsDlg* parent) : CTrueDialog(IDD_PG_ABOUT)
{
	m_parent = parent;
}

CPageAbout::~CPageAbout(void)
{
}

void CPageAbout::OnInitDialog(void)
{
	TCHAR str[MAX_PATH];
	GetModuleFileName(g_hInst, str, MAX_PATH);
	DWORD versionLS, versionMS;
	GetFileVersion(str, versionMS, versionLS);

	TCHAR strVer[255];
	Version2Str(versionMS, versionLS, strVer);
	TCHAR strText[255];
	wsprintf(strText, TEXT("v%s"), strVer);

	SetDlgItemText(m_hWnd, IDC_VERSION, strText);
}

void CPageAbout::OnPaint(void)
{
	PAINTSTRUCT ps;
	BeginPaint(m_hWnd, &ps);

	RECT rc;
	GetWindowRect(GetDlgItem(m_hWnd, IDC_LOGO), &rc);
	MapWindowPoints(NULL, m_hWnd, (LPPOINT) &rc, 2);

	// TODO: Draw logo into "rc" rect
	CxImage imgLogo;
	imgLogo.LoadResource(FindResource(g_hInst, MAKEINTRESOURCE(IDR_LOGO), TEXT("PNG")), CXIMAGE_FORMAT_PNG, g_hInst);
	imgLogo.Draw(ps.hdc, rc.left, rc.top);

	EndPaint(m_hWnd, &ps);
}

//////////////////////////////////////////////////////////////////////////

CPageOptions::CPageOptions(CPropsDlg* parent) : CTrueDialog(IDD_PG_OPTIONS)
{
	m_parent = parent;
}

CPageOptions::~CPageOptions(void)
{
}

void CPageOptions::OnInitDialog()
{
	SendDlgItemMessage(m_hWnd, IDC_HOTKEY, HKM_SETHOTKEY, m_parent->m_hotKey, NULL);
}

BOOL CPageOptions::OnEndDialog()
{
	m_parent->m_hotKey = (WORD) SendDlgItemMessage(m_hWnd, IDC_HOTKEY, HKM_GETHOTKEY, 0, NULL);

	return TRUE;
}


//////////////////////////////////////////////////////////////////////////

CPropsDlg::CPropsDlg(void) : CTrueDialog(IDD_PROPERTIES)
{
}

CPropsDlg::~CPropsDlg(void)
{
}
