#pragma once
#include "arrays.h"

#define AMID_PROCNAME	1
#define AMID_CAPTION	2

class CWndLstBtn :	public CTlbButton
{
	HICON	m_tipIcon;

	CTArray<WINDOW_ITEM>	m_windows;
	CRITICAL_SECTION		m_sync;

	HANDLE					m_changesHandle;

	HANDLE	m_hTimerThread;	// Handle of timer thread
	HANDLE	m_hStop;		// Handle to event to stop timer thread

	static DWORD WINAPI TimerTrdProc(LPVOID lpParam); // Static timer proc
	void TimerThread();
	void StartTimer();
	void StopTimer();

	static BOOL CALLBACK EnumWindowsProc(HWND hwnd, LPARAM lParam);

	void ClearItems();
public:
	CWndLstBtn(void);
	virtual ~CWndLstBtn(void);

	void	LockItems();
	void	UnlockItems();
	BOOL	isDeleted(HWND hWnd);
	BOOL	getWindowChanges(HWND hWnd, WND_CHANGES* changes);
	void	CloseApp(LPTSTR appname);

	virtual BOOL isMenu();
	virtual UINT GetMenuFlags();

	virtual BOOL Save(IStream *data);
	virtual BOOL Load(IStream *data);

	virtual void GetButtonText(LPWSTR text);

	virtual BOOL LoadIcon(int size);
	virtual BOOL SetIconLocation(LPCWSTR szLocation);
	virtual BOOL OnCreate();
	virtual UINT GetSupportedActions();
	virtual UINT GetModeFlags();

	virtual HICON GetTipIcon(int tipID);

	virtual HANDLE	GetChangesHandle();
	virtual void	PrepareChanges(HANDLE hChanges);
	virtual void	CloseChangesHandle(HANDLE hChanges);
	virtual BOOL	FirstChildData(CHILDS_DATA* data);
	virtual BOOL	NextChildData(CHILDS_DATA* data);
	virtual BOOL	FreeChildData(CHILDS_DATA* data);
	virtual BOOL	CreateChild(CREATE_CHILD_DATA* childData);

	virtual BOOL SupportSortMenu(void);
	virtual void CompareButtons(COMPARE_BUTTONS_DATA* cpBtns);
	virtual BOOL QueryArrangeMenu(UINT idx, ARRANGE_MENU_DATA* qamData);
};
